use crate::experimental::trait_based::data::io::Inputs;

use super::data::io::Outputs;

pub(crate) trait PipelineElement {
    fn runner(&self) -> fn(&Inputs) -> Outputs;
    fn signature(&self) -> ElementIo;
}

pub(crate) struct ElementIo {
    pub inputs: Vec<DataType>,
    pub outputs: Vec<DataType>,
}

#[derive(Clone, Copy, PartialEq, Eq, Debug)]
pub enum DataType {
    String,
    Int,
}
